﻿Imports System.Data.Linq
Imports System.Data.Linq.Mapping
Imports System.Reflection


Public Class LiaDataContext
    Public Function LoadBooks(ByVal subj As Subject) As IEnumerable(Of Book)
        Return Me.LoadSubjectBooks(subj.ID)
    End Function

    <[Function](IsComposable:=False)> _
    <ResultType(GetType(Subject))> _
    <ResultType(GetType(Book))> _
    Private Function GetSubjectAndBooks() As IMultipleResults
        Dim res = Me.ExecuteMethodCall(Me, CType(MethodInfo.GetCurrentMethod, MethodInfo))
        Return CType(res.ReturnValue, IMultipleResults)
    End Function

    Public Function GetSubjectsWithBooks() As List(Of Subject)
        Dim results As IMultipleResults = Me.GetSubjectAndBooks
        Dim Subjects = results.GetResult(Of Subject).ToList
        Dim Books = results.GetResult(Of Book).ToList
        For Each s In Subjects
            Dim thisId As Guid = s.ID
            s.FetchedBooks = (From b In Books Where b.SubjectId = thisId).ToList
        Next
        Return Subjects
    End Function

    Public Shared DescendingSubjects As Func(Of LiaDataContext, IQueryable(Of Subject)) = _
        CompiledQuery.Compile(Function(context As LiaDataContext) _
                                  From s In context.Subjects _
                                  Order By s.Name Descending _
                                  Select s)

    Public Function LoadSubject(ByVal value As Book) As Subject
        Return Me.LoadSubject(value.SubjectId).SingleOrDefault
    End Function
End Class